"use strict";

module.exports = function splitFilter(array, ensureCategories, predicate) {
	let results = {};

	if (ensureCategories != null) {
		for (let category of ensureCategories) {
			results[category] = [];
		}
	}

	for (let item of array) {
		let category = predicate(item);

		if (category != null) {
			if (results[category] == null) {
				results[category] = [];
			}

			results[category].push(item);
		}
	}

	return results;
};
